var foutname="myScript.js";
var rawname="tmp.raw";

// Convert to RGB

function ConvertToRGB()
{
var idCnvM = charIDToTypeID( "CnvM" ); 
    var desc1 = new ActionDescriptor();
    var idT = charIDToTypeID( "T   " );
    var idRGBM = charIDToTypeID( "RGBM" );
    desc1.putClass( idT, idRGBM );
executeAction( idCnvM, desc1, DialogModes.NO );
}

// Make and fill alphachannel

function MakeAndFillAlpha()
{
var idMk = charIDToTypeID( "Mk  " );
    var desc2 = new ActionDescriptor();
    var idNw = charIDToTypeID( "Nw  " );
        var desc3 = new ActionDescriptor();
        var idClrI = charIDToTypeID( "ClrI" );
        var idMskI = charIDToTypeID( "MskI" );
        var idMskA = charIDToTypeID( "MskA" );
        desc3.putEnumerated( idClrI, idMskI, idMskA );
        var idClr = charIDToTypeID( "Clr " );
            var desc4 = new ActionDescriptor();
            var idRd = charIDToTypeID( "Rd  " );
            desc4.putDouble( idRd, 255.000000 );
            var idGrn = charIDToTypeID( "Grn " );
            desc4.putDouble( idGrn, 0.000000 );
            var idBl = charIDToTypeID( "Bl  " );
            desc4.putDouble( idBl, 0.000000 );
        var idRGBC = charIDToTypeID( "RGBC" );
        desc3.putObject( idClr, idRGBC, desc4 );
        var idOpct = charIDToTypeID( "Opct" );
        desc3.putInteger( idOpct, 50 );
    var idChnl = charIDToTypeID( "Chnl" );
    desc2.putObject( idNw, idChnl, desc3 );
executeAction( idMk, desc2, DialogModes.NO );

// =======================================================
var idsetd = charIDToTypeID( "setd" );
    var desc5 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref1 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idfsel = charIDToTypeID( "fsel" );
        ref1.putProperty( idChnl, idfsel );
    desc5.putReference( idnull, ref1 );
    var idT = charIDToTypeID( "T   " );
    var idOrdn = charIDToTypeID( "Ordn" );
    var idAl = charIDToTypeID( "Al  " );
    desc5.putEnumerated( idT, idOrdn, idAl );
executeAction( idsetd, desc5, DialogModes.NO );

// =======================================================
var idFl = charIDToTypeID( "Fl  " );
    var desc6 = new ActionDescriptor();
    var idUsng = charIDToTypeID( "Usng" );
    var idFlCn = charIDToTypeID( "FlCn" );
    var idWht = charIDToTypeID( "Wht " );
    desc6.putEnumerated( idUsng, idFlCn, idWht );
    var idOpct = charIDToTypeID( "Opct" );
    var idPrc = charIDToTypeID( "#Prc" );
    desc6.putUnitDouble( idOpct, idPrc, 100.000000 );
    var idMd = charIDToTypeID( "Md  " );
    var idBlnM = charIDToTypeID( "BlnM" );
    var idNrml = charIDToTypeID( "Nrml" );
    desc6.putEnumerated( idMd, idBlnM, idNrml );
executeAction( idFl, desc6, DialogModes.NO );
}

// Convert to multichannel and up alpha

function ConvertAndSaveMultichannel()
{
// =======================================================
var idCnvM = charIDToTypeID( "CnvM" );
    var desc7 = new ActionDescriptor();
    var idT = charIDToTypeID( "T   " );
    var idMltC = charIDToTypeID( "MltC" );
    desc7.putClass( idT, idMltC );
executeAction( idCnvM, desc7, DialogModes.NO );

//app.ActiveDocument.channels[3].name="Alpha 1";

// =======================================================
var idslct = charIDToTypeID( "slct" );
    var desc107 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref27 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
  //      ref27.putName( idChnl, "Alpha 1" );
        ref27.putIndex( idChnl,4 );
    desc107.putReference( idnull, ref27 );
executeAction( idslct, desc107, DialogModes.NO );

// =======================================================
var idmove = charIDToTypeID( "move" );
    var desc8 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref2 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idOrdn = charIDToTypeID( "Ordn" );
        var idTrgt = charIDToTypeID( "Trgt" );
        ref2.putEnumerated( idChnl, idOrdn, idTrgt );
    desc8.putReference( idnull, ref2 );
    var idT = charIDToTypeID( "T   " );
        var ref3 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        ref3.putIndex( idChnl, 1 );
    desc8.putReference( idT, ref3 );
executeAction( idmove, desc8, DialogModes.NO );

// =======================================================
var idsave = charIDToTypeID( "save" );
    var desc9 = new ActionDescriptor();
    var idAs = charIDToTypeID( "As  " );
        var desc10 = new ActionDescriptor();
        var idFlCr = charIDToTypeID( "FlCr" );
        desc10.putString( idFlCr, """8BIM""" );
        var idChnI = charIDToTypeID( "ChnI" );
        desc10.putBoolean( idChnI, true );
    var idRw = charIDToTypeID( "Rw  " );
    desc9.putObject( idAs, idRw, desc10 );
    var idIn = charIDToTypeID( "In  " );
    desc9.putPath( idIn, new File( rawname ) );
    var idDocI = charIDToTypeID( "DocI" );
    desc9.putInteger( idDocI, 1118 );
    var idCpy = charIDToTypeID( "Cpy " );
    desc9.putBoolean( idCpy, true );
    var idsaveStage = stringIDToTypeID( "saveStage" );
    var idsaveStageType = stringIDToTypeID( "saveStageType" );
    var idsaveBegin = stringIDToTypeID( "saveBegin" );
    desc9.putEnumerated( idsaveStage, idsaveStageType, idsaveBegin );
executeAction( idsave, desc9, DialogModes.NO );

// =======================================================
var idsave = charIDToTypeID( "save" );
    var desc11 = new ActionDescriptor();
    var idAs = charIDToTypeID( "As  " );
        var desc12 = new ActionDescriptor();
        var idFlCr = charIDToTypeID( "FlCr" );
        desc12.putString( idFlCr, """8BIM""" );
        var idChnI = charIDToTypeID( "ChnI" );
        desc12.putBoolean( idChnI, true );
    var idRw = charIDToTypeID( "Rw  " );
    desc11.putObject( idAs, idRw, desc12 );
    var idIn = charIDToTypeID( "In  " );
    desc11.putPath( idIn, new File( rawname ) );
    var idDocI = charIDToTypeID( "DocI" );
    desc11.putInteger( idDocI, 1118 );
    var idCpy = charIDToTypeID( "Cpy " );
    desc11.putBoolean( idCpy, true );
    var idsaveStage = stringIDToTypeID( "saveStage" );
    var idsaveStageType = stringIDToTypeID( "saveStageType" );
    var idsaveSucceeded = stringIDToTypeID( "saveSucceeded" );
    desc11.putEnumerated( idsaveStage, idsaveStageType, idsaveSucceeded );
executeAction( idsave, desc11, DialogModes.NO );
}

function DuplicateImage()
{
var idDplc = charIDToTypeID( "Dplc" );
    var desc29 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref12 = new ActionReference();
        var idDcmn = charIDToTypeID( "Dcmn" );
        var idOrdn = charIDToTypeID( "Ordn" );
        var idFrst = charIDToTypeID( "Frst" );
        ref12.putEnumerated( idDcmn, idOrdn, idFrst );
    desc29.putReference( idnull, ref12 );
    var idNm = charIDToTypeID( "Nm  " );
    desc29.putString( idNm, """opy""" );
executeAction( idDplc, desc29, DialogModes.NO );
}

function toHexString(str)
{
  var hexSt="";
  for (var i = 0; i < str.length; ++i)
  {
    charCode =str.charCodeAt(i);
    hexSt+=(charCode>>4).toString(16);
    hexSt+=(charCode & 0xF).toString(16);
  }
  return hexSt;
}


function CloseImage()
{
//var idCls = charIDToTypeID( "Cls " );
//executeAction( idCls, undefined, DialogModes.NO );
 app.activeDocument.close(SaveOptions.DONOTSAVECHANGES);
}

function out_dir_onClick()
{
 var file = new File(foutname);
 foutname = file.openDlg("Select output JS file","JavaScript files:*.js");
 z.out_dir.text = "Output JS file: "+foutname;
}

function CreateScriptFromFile()
{
  var title=z.buttonname.text;
  var label=z.buttonlabel.text;
  var cd=z.code.text;
  app.preferences.typeUnits = TypeUnits.PIXELS;

  var f = new File(rawname);
  f.encoding = 'BINARY';  
  f.open('r'); 
  var icondata = f.read(); 
 
  f.close(); 
  
  var fout = new File(foutname);  
  fout.open('w'); 
  
  fout.write("//Template of this script produced by CreateAcrobatScript\r\n//Copyright (c) Mikhail V. Kondakov (MBK) 2016\r\n//mbkhome.narod.ru mikhail_kondakov@mail.ru\r\n\r\nvar myIconStream = \"");
  fout.write(toHexString(icondata));
  fout.write("\";\r\n\r\nvar oIcon = { count: 0, width: "+app.activeDocument.width.value);
  fout.write(", height: "+app.activeDocument.height.value);
  fout.write(", \r\n  read: function(nBytes) {return myIconStream.slice(this.count, this.count += nBytes)}, \r\n  GetIcon: function() {this.count = 0; return this;} };\r\n");
  fout.write("\r\nvar myButtonPress = app.trustedFunction(function(){\r\n  app.beginPriv();\r\n");
  fout.write("  "+cd+"\r\n");
  fout.write("  app.endPriv();\r\n  return;\r\n});\r\n\r\n");
  fout.write("if (app.viewerVersion < 10) {\r\n");
  fout.write("  app.addMenuItem({ cName: \""+title+"\", cUser: \""+label+"\", cParent: \"Tools\", cExec: \"myButtonPress()\",\r\n");
  fout.write("    cEnable: \"event.rc = (event.target != null);\"});\r\n");
  fout.write("} else {");
  fout.write("  app.addToolButton({ cName: \""+title+"\", cLabel: \""+label+"\", oIcon: oIcon,  cExec: \"myButtonPress()\",\r\n");
  fout.write("    cEnable: \"event.rc = (event.target != null);\"});\r\n");
  fout.write("}\r\n");

 
  fout.close(); 
}

function saveB_onClick()
{
 DuplicateImage();
 if (app.activeDocument.mode!=DocumentMode.RGB)
 {
   ConvertToRGB();
 }
 if (app.activeDocument.channels.length>4)
 {
   CloseImage();
   alert("Too match channels!");
   z.close();
 } else
 {
   if (app.activeDocument.channels.length==3)
   {
     MakeAndFillAlpha();
   }
   ConvertAndSaveMultichannel();
   CreateScriptFromFile();
   CloseImage();
   z.close();
 }
}



if (app.documents.length == 0)
{
  alert("Please, open icon image");
} else
{
if ((app.activeDocument.mode!=DocumentMode.BITMAP) && (app.activeDocument.mode!=DocumentMode.MULTICHANNEL))
{

z = new Window("dialog","Create Acrobat Script");

z.frameLocation = [500,300];
z.size = [300,350];
z.out_dir = z.add("button",[10,11,290,30],"Output JS file: "+foutname);
z.buttonname = z.add("edittext",[90,43,290,63],"My Great Script");

z.buttonnameText = z.add("statictext",[10,45,85,65],"Button name: ");
z.buttonlabel = z.add("edittext",[90,65,290,85],"My Great Script");

z.buttonlabelText = z.add("statictext",[10,67,80,85],"Button label: ");
z.code = z.add("edittext",[90,87,290,290],"app.alert(\"Hello world!\");");

z.codeText = z.add("statictext",[10,89,80,107],"Code: ");

z.saveB = z.add("button",[210,295,295,340],"Save JS file");

z.out_dir.onClick = out_dir_onClick;
z.saveB.onClick = saveB_onClick;

z.show();
} else
{ 
 alert("Wrong icon mode!");
}
}